/* Auto-generated, do not edit.
 *
 * This file may be distributed under the same terms
 * as the specification from which it was generated.
 */

/**
 * HAZE_HASH_TYPE_MAIL:
 *
 * An extensible map representing a mail, or (on protocols where         &lt;tt&gt;Thread_Based&lt;/tt&gt; appears in         &lt;tp:member-ref&gt;MailNotificationFlags&lt;/tp:member-ref&gt;) a thread of         mails. All keys are optional where not otherwise stated; however, at         least one of &amp;quot;senders&amp;quot; and &amp;quot;subject&amp;quot; must be included.
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GHashTable
 * appropriate for representing a D-Bus
 * dictionary of signature
 * <literal>a{sv}</literal>.
 *
 * Keys (D-Bus type <literal>s</literal>,
 * named <literal>Key</literal>):
 * &lt;p&gt;A key providing information about the mail or thread. Well-known             keys are as follows:&lt;/p&gt;          &lt;dl&gt;           &lt;dt&gt;id — s&lt;/dt&gt;           &lt;dd&gt;             &lt;p&gt;A unique ID for this e-mail. CMs with               &lt;tt&gt;Supports_Unread_Mails&lt;/tt&gt; set in               &lt;tp:member-ref&gt;MailNotificationFlags&lt;/tp:member-ref&gt; MUST provide               this key in each &lt;tp:type&gt;Mail&lt;/tp:type&gt;.&lt;/p&gt;              &lt;p&gt;If provided, the ID SHOULD be unique to a Mail at least until               that mail is removed with the               &lt;tp:member-ref&gt;UnreadMailsChanged&lt;/tp:member-ref&gt; signal               (in protocols with &lt;tt&gt;Supports_Unread_Emails&lt;/tt&gt;), or               unique for the duration of a session (otherwise).&lt;/p&gt;              &lt;tp:rationale&gt;               &lt;p&gt;In protocols with Supports_Unread_Mails, this key is used to                 indicate which mail was removed. In protocols without that                 feature, it&apos;s impossible to tell when a mail has been removed                 (and hence how long the identifier will remain valid for use                 with &lt;tp:member-ref&gt;RequestMailURL&lt;/tp:member-ref&gt;).&lt;/p&gt;             &lt;/tp:rationale&gt;           &lt;/dd&gt;            &lt;dt&gt;url-data — any type&lt;/dt&gt;           &lt;dd&gt;An opaque identifier (typically a string or list of strings)             provided to the Connection when calling             &lt;tp:member-ref&gt;RequestMailURL&lt;/tp:member-ref&gt;,             containing information used by the Connection to build the URL.           &lt;/dd&gt;            &lt;dt&gt;senders — a(ss) (&lt;tp:type&gt;Mail_Address&lt;/tp:type&gt;)&lt;/dt&gt;           &lt;dd&gt;             An array of sender display name and e-mail address pairs. Note that             only e-mails represented as a thread can have multiple senders.           &lt;/dd&gt;            &lt;dt&gt;to-addresses — a(ss) (&lt;tp:type&gt;Mail_Address&lt;/tp:type&gt;)&lt;/dt&gt;           &lt;dd&gt;             An array of display name and e-mail address pairs representing             the recipients.           &lt;/dd&gt;            &lt;dt&gt;cc-addresses — a(ss) (&lt;tp:type&gt;Mail_Address&lt;/tp:type&gt;)&lt;/dt&gt;           &lt;dd&gt;             An array of display name and e-mail address pairs representing             the carbon-copy recipients.           &lt;/dd&gt;            &lt;dt&gt;sent-timestamp — x (&lt;tp:type&gt;Unix_Timestamp64&lt;/tp:type&gt;)&lt;/dt&gt;           &lt;dd&gt;A UNIX timestamp indicating when the message was sent, or for             a thread, when the most recent message was sent.           &lt;/dd&gt;            &lt;dt&gt;received-timestamp — x (&lt;tp:type&gt;Unix_Timestamp64&lt;/tp:type&gt;)&lt;/dt&gt;           &lt;dd&gt;A UNIX timestamp indicating when the message was received, or for             a thread, when the most recent message was received.           &lt;/dd&gt;            &lt;dt&gt;has-attachments — b&lt;/dt&gt;           &lt;dd&gt;If true, this mail has attachments.&lt;/dd&gt;            &lt;dt&gt;subject — s&lt;/dt&gt;           &lt;dd&gt;             The subject of the message. This MUST be encoded in UTF-8.           &lt;/dd&gt;            &lt;dt&gt;content-type — s&lt;/dt&gt;           &lt;dd&gt;             &lt;p&gt;The MIME type of the message content. Two types are currently               supported: &amp;quot;text/plain&amp;quot; for plain text, and &amp;quot;text/html&amp;quot; for a               HTML document. If omitted, &amp;quot;text/plain&amp;quot; MUST be assumed.               Regardless of MIME type, the content MUST be valid UTF-8 (which               may require that the Connection transcodes it from a legacy               encoding).&lt;/p&gt;              &lt;tp:rationale&gt;               &lt;p&gt;All strings on D-Bus must be UTF-8.&lt;/p&gt;             &lt;/tp:rationale&gt;           &lt;/dd&gt;            &lt;dt&gt;truncated — b&lt;/dt&gt;           &lt;dd&gt;             If true, the content is only a partial message; if false or             omitted, the content is the entire message.           &lt;/dd&gt;            &lt;dt&gt;content — s&lt;/dt&gt;           &lt;dd&gt;             The body of the message, possibly truncated, encoded as appropriate             for &amp;quot;content-type&amp;quot;.           &lt;/dd&gt;            &lt;dt&gt;folder — s&lt;/dt&gt;           &lt;dd&gt;             The name of the folder containing this e-mails.             If omitted, the inbox SHOULD be assumed.           &lt;/dd&gt;         &lt;/dl&gt;
 *
 * Values (D-Bus type <literal>v</literal>,
 * named <literal>Value</literal>):
 * The value, of whatever type is appropriate for the           key.
 *
 */
#define HAZE_HASH_TYPE_MAIL (haze_type_dbus_hash_sv ())

/**
 * HAZE_ARRAY_TYPE_MAIL_LIST:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #HAZE_HASH_TYPE_MAIL.
 */
#define HAZE_ARRAY_TYPE_MAIL_LIST (haze_type_dbus_array_of_a_7bsv_7d ())

GType haze_type_dbus_hash_sv (void);

/**
 * HAZE_STRUCT_TYPE_HTTP_POST_DATA:

 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;
	
        
	&lt;p&gt;
		A pair (key, value) representing POST data compatible with the
        application/x-www-form-urlencoded MIME type. The strings MUST be
        valid UTF-8 strings, and the characters used in the key MUST obey
        the requirements of the
        
		&lt;a href=&quot;http://www.w3.org/TR/html401/types.html#type-cdata&quot;&gt;
			
          HTML CDATA type
		&lt;/a&gt;
		. The value MUST NOT be
        encoded with HTML entities.
	&lt;/p&gt;
	

        
	&lt;p&gt;
		For example, if the POST data should contain a key &amp;quot;less-than&amp;quot; with value
        &amp;quot;&amp;lt;&amp;quot;, and a key &amp;quot;percent&amp;quot; with value &amp;quot;%&amp;quot;, this should be represented as
        two HTTP_Post_Data structures, (&amp;quot;less-than&amp;quot;, &amp;quot;&amp;lt;&amp;quot;) and (&amp;quot;percent&amp;quot;, &amp;quot;%&amp;quot;),
        resulting in a POST request whose request body is &amp;quot;less-than=&amp;amp;lt;&amp;amp;percent=%25&amp;quot;.
        If a client passes this to a browser by writing it into an HTML form, it
        could do so by representing it as:
	&lt;/p&gt;
	

        
	&lt;pre&gt;
		
        &amp;lt;input type=&amp;quot;hidden&amp;quot; name=&amp;quot;less-than&amp;quot;&amp;gt;&amp;amp;lt;&amp;lt;/input&amp;gt;
        &amp;lt;input type=&amp;quot;hidden&amp;quot; name=&amp;quot;percent&amp;quot;&amp;gt;%&amp;lt;/input&amp;gt;
        
	&lt;/pre&gt;
	

        
	&lt;tp:rationale&gt;
		
          
		&lt;p&gt;
			This data can be used to generate a HTML file that will
            automatically load the URL with appropriate POST data, in which case
            the client MUST convert any characters that are special within HTML
            into HTML entities. Alternatively, it can be used in an API that will
            instruct the browser how to load the URL (like the Netscape Plug-in
            API), in which case the client MUST escape
            
			&lt;a href=&quot;http://www.ietf.org/rfc/rfc1738.txt&quot;&gt;
				characters that are
              reserved in URLs
			&lt;/a&gt;
			, if appropriate for that API.
		&lt;/p&gt;
		

          
		&lt;p&gt;
			An array of pairs is used instead of a map from keys to values,
            because it&apos;s valid to repeat keys in both HTML and
            x-www-form-urlencoded data.
		&lt;/p&gt;
		
        
	&lt;/tp:rationale&gt;
	
      

 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(ss)</literal>.
 *
 * Member 0 (D-Bus type <literal>s</literal>,
 * named <literal>Key</literal>):
 * The key, corresponding to a HTML control           name
 *
 * Member 1 (D-Bus type <literal>s</literal>,
 * named <literal>Value</literal>):
 * The value
 *
 */
#define HAZE_STRUCT_TYPE_HTTP_POST_DATA (haze_type_dbus_struct_ss ())

/**
 * HAZE_ARRAY_TYPE_HTTP_POST_DATA_LIST:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #HAZE_STRUCT_TYPE_HTTP_POST_DATA.
 */
#define HAZE_ARRAY_TYPE_HTTP_POST_DATA_LIST (haze_type_dbus_array_ss ())

/**
 * HAZE_STRUCT_TYPE_MAIL_ADDRESS:

 * 
	
        A pair (name, address) representing an e-mail address,
        such as (&amp;quot;Nicolas Dufresne&amp;quot;, &amp;quot;nicolas.dufresne@collabora.co.uk&amp;quot;).
      

 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(ss)</literal>.
 *
 * Member 0 (D-Bus type <literal>s</literal>,
 * named <literal>Name</literal>):
 * The displayed name corresponding to the e-mail           address
 *
 * Member 1 (D-Bus type <literal>s</literal>,
 * named <literal>Address</literal>):
 * The actual e-mail address
 *
 */
#define HAZE_STRUCT_TYPE_MAIL_ADDRESS (haze_type_dbus_struct_ss ())

/**
 * HAZE_ARRAY_TYPE_MAIL_ADDRESS_LIST:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #HAZE_STRUCT_TYPE_MAIL_ADDRESS.
 */
#define HAZE_ARRAY_TYPE_MAIL_ADDRESS_LIST (haze_type_dbus_array_ss ())

/**
 * HAZE_STRUCT_TYPE_MAIL_URL:

 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;
	
        
	&lt;p&gt;
		A structure containing the required information to open a web-based
          e-mail UI, without needing re-authentication (if possible).
	&lt;/p&gt;
	

        
	&lt;p&gt;
		Because the URL and POST data frequently contain short-lived
          credential tokens, a new URL should be requested (by calling one of
          the methods that returns a Mail_URL) for each visit to the web-based
          UI, and the URL should be visited soon after it is returned.
	&lt;/p&gt;
	
      

 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(sua(ss))</literal>.
 *
 * Member 0 (D-Bus type <literal>s</literal>,
 * named <literal>URL</literal>):
 * The URL to which to send a request.
 *
 * Member 1 (D-Bus type <literal>u</literal>,
 * type <literal>HTTP_Method</literal>,
 * named <literal>Method</literal>):
 * The HTTP method of the request.
 *
 * Member 2 (D-Bus type <literal>a(ss)</literal>,
 * type <literal>HTTP_Post_Data[]</literal>,
 * named <literal>Post_Data</literal>):
 * An array of name-value pairs containing the POST data to use when           opening the URL. This MUST be an empty array if the Method is not           POST.
 *
 */
#define HAZE_STRUCT_TYPE_MAIL_URL (haze_type_dbus_struct_sua_28ss_29 ())

GType haze_type_dbus_struct_ss (void);

GType haze_type_dbus_struct_sua_28ss_29 (void);

GType haze_type_dbus_array_ss (void);

GType haze_type_dbus_array_of_a_7bsv_7d (void);

